; === Wait for approx. 1 millisecond ===
.equ WAIT1MS_CPU_CYCLES = ROUND(0.001*F_CPU/10.0)
.if WAIT1MS_CPU_CYCLES > 0xFFFF
.error "Routine wait1ms needs a third counter register."
.endif
wait1ms:
	push	tmpL
	push	tmpH
	ldi		tmpL, low(WAIT1MS_CPU_CYCLES)
	ldi		tmpH, high(WAIT1MS_CPU_CYCLES)
wait1ms_loop:
	nop
	nop
	nop
	nop
	nop
	nop
	sbiw	tmpH:tmpL, 1
	brne	wait1ms_loop
	pop		tmpH
	pop		tmpL
	ret

; === Wait for approx. 5 milliseconds ===
.equ WAIT5MS_CPU_CYCLES = ROUND(0.005*F_CPU/10.0)
.if WAIT5MS_CPU_CYCLES > 0xFFFF
.error "Routine wait5ms needs a third counter register."
.endif
wait5ms:
	push	tmpL
	push	tmpH
	ldi		tmpL, low(WAIT5MS_CPU_CYCLES)
	ldi		tmpH, high(WAIT5MS_CPU_CYCLES)
wait5ms_loop:
	nop
	nop
	nop
	nop
	nop
	nop
	sbiw	tmpH:tmpL, 1
	brne	wait5ms_loop
	pop		tmpH
	pop		tmpL
	ret

; === Wait for approx. 25 milliseconds ===
.equ WAIT25MS_CPU_CYCLES = ROUND(0.025*F_CPU/10.0)
.if WAIT25MS_CPU_CYCLES > 0xFFFF
.error "Routine wait25ms needs a third counter register."
.endif
wait25ms:
	push	tmpL
	push	tmpH
	ldi		tmpL, low(WAIT25MS_CPU_CYCLES)
	ldi		tmpH, high(WAIT25MS_CPU_CYCLES)
wait25ms_loop:
	nop
	nop
	nop
	nop
	nop
	nop
	sbiw	tmpH:tmpL, 1
	brne	wait25ms_loop
	pop		tmpH
	pop		tmpL
	ret
